<?
require_once("ircclient.php");
require_once("irc_config.php");

function irc_on_connect ( $data, $irc)
{
    global $irclink;
    /* We connected successfully. Send oper and scriptreg */
    $irc->irc_send_msg($irclink["opercmd"]);
    $irc->irc_send_msg($irc->send);
}

function irc_on_nicknameinuse ( $data, $object )
{
    global $irc;
    $irc->actual_nick = "{$irc->actual_nick}_";
    $irc->irc_send_msg (sprintf ("NICK %s", $irc->actual_nick));
}

function irc_on_timeout($data, $irc)
{
    $irc->disconnect("TIMEOUT");
}

function makebot($send, $irc_on_privmsg_func)
{
    global $irclink;
    $irc = new IRCClient($irclink['nick'], $irclink['user'], $irclink['name'], $irclink['host']);
    $irc->send = $send;
    $irc->irc_register_callback ('001', 'irc_on_connect');
    $irc->irc_register_callback ('433', 'irc_on_nicknameinuse');
    $irc->irc_register_callback ('PRIVMSG', "$irc_on_privmsg_func");
    $irc->irc_register_callback ('NOTICE', "$irc_on_privmsg_func");
    $irc->irc_register_callback ('timeout', "irc_on_timeout");
    $irc->irc_connect($irclink["server"]); /* This blocks until the connection is done, returns $irc->return */
    return $irc->return;
}

/* ** 
   REGISTER : 
 */
function attempt_register_on_privmsg($message, $irc)
{
    
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'*Account has been registered to you.*'))
    {
      $irc->disconnect("OK");
      return TRUE;
    }
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'That email address already has an unused cookie outstanding.*'))
    {
        $irc->disconnect("DUPLICATE EMAIL");
        return FALSE;
    }
    else if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'*'))
    {
      $irc->disconnect("UNKNOWN MESSAGE $message->message");
      return FALSE;
    }
    return TRUE;
}

function attempt_register($accountname, $password, $email)
{
   return(makebot("PRIVMSG AUTHSERV@X3.AfterNET.Services :REGISTER $accountname $password $email WEBLINK", "attempt_register_on_privmsg"));
}

/* ** 
   COOKIE : 
 */
function attempt_cookie_on_privmsg($message, $irc)
{
    
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'Your account is now activated*'))
    {
      $irc->disconnect("OK");
      return TRUE;
    }
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'You have successfully changed your password to what you requested*'))
    {
      $irc->disconnect("OK");
      return TRUE;
    }
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'That cookie is not the right one.*'))
    {
        $irc->disconnect("WRONG COOKIE");
        return FALSE;
    }
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'Your account does not have any cookie issued*'))
    {
        $irc->disconnect("NO COOKIES ISSUED");
        return FALSE;
    }
    else if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'*'))
    {
      $irc->disconnect("UNKNOWN MESSAGE $message->message");
      return FALSE;
    }
    return TRUE;
}

function attempt_cookie($accountname, $cookie)
{
   return(makebot("PRIVMSG AuthServ@X3.AfterNET.Services :COOKIE $accountname $cookie", "attempt_cookie_on_privmsg"));
}

/* ** 
   RESETPASS : 
 */
function attempt_resetpass_on_privmsg($message, $irc)
{
    
    if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'A cookie has been mailed to your account\'s email address*'))
    {
      $irc->disconnect("OK");
      return TRUE;
    }
    else if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'Account * already has a cookie active*'))
    {
        $irc->disconnect("COOKIE ALREADY ACTIVE");
        return FALSE;
    }
    else if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'Your password must be at least*'))
    {
        $irc->disconnect("PASSWORD TOO SHORT");
        return FALSE;
    }
    else if($message->matches('AuthServ!AuthServ@X3.AfterNET.Services','NOTICE',$irc->actual_nick,'*'))
    {
      $irc->disconnect("UNKNOWN MESSAGE $message->message");
      return FALSE;
    }
    return TRUE;
}
function attempt_resetpass($accountname, $password)
{
   return(makebot("PRIVMSG AuthServ@X3.AfterNET.Services :RESETPASS $accountname $password WEBLINK", "attempt_resetpass_on_privmsg"));
}

// EXAMPLE
//$result = attempt_register("playtest7", "fooplaytest7", "playtest7@simulatedplanet.org");
//echo "Got $result from attempt_register<BR>";

?>
