/* Copyright AfterNET 2004
 *
 * Licensed under the GNU General Public License version 2.0
 *
 * This little tool moves the sync log to sync/tmpsync-xxxxxxxxx.log
 * and prints its contents to stdout. It is a part of the AfterNET
 * srvx2 -> mambo integration scheme. It can be run suid so that
 * external users (such as www-data) can process the sync log.
 */
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>

#define SRVXDIR "/home/path/to/your/srvx2/"
#define LOGFILE "sync.log"
#define SYNCDIR  SRVXDIR "sync/"
#define TEMPFILE SYNCDIR "tmpsync-%lu.log"
#define SYNCLOG SRVXDIR LOGFILE

int main()
{
    FILE *handle;
    char buff[2048];
    char tempfile[2048];
    DIR *dir;

    sprintf(tempfile, TEMPFILE, time());
    if((dir = opendir(SYNCDIR)) == NULL)
    {
        mkdir(SYNCDIR);
    }
    else
    {
        closedir(dir);
    }

    rename(SYNCLOG, tempfile);

    /* Move the log file to another name */
    handle = fopen(tempfile, "r");
    if(handle)
    {
        while(!feof(handle))
        {
            strcpy(buff, "");
            fgets(buff, 2048, handle);
            printf("%s", buff);
        }
    }
}
